package org.ffd2.skeletonx.austenx.peg.base;
public final class JavaExpressionPeer {
	public static interface Indirect {
		public JavaExpressionPeer.BinaryPatternPeer createBinary() ;
		public JavaExpressionPeer.GeneralBinaryPatternPeer createGeneralBinary(int symbolLine, int symbolCharacter) ;
		public JavaExpressionPeer.PostUnaryPatternPeer createPostUnary() ;
		public JavaExpressionPeer.PreUnaryPatternPeer createPreUnary() ;
		public JavaExpressionPeer.AssignmentPatternPeer createAssignment(int keywordLine, int keywordCharacter) ;
		public JavaExpressionPeer.MappingVariableRefPatternPeer createMappingVariableRef() ;
		public JavaExpressionPeer.CallPatternPeer createCall() ;
		public JavaExpressionPeer.BracketedPatternPeer createBracketed(int keywordLine, int keywordCharacter) ;
		public JavaExpressionPeer.BuilderVariableRefPatternPeer createBuilderVariableRef() ;
		public JavaExpressionPeer.ArrayConstructorCallPatternPeer createArrayConstructorCall(int keywordLine, int keywordCharacter) ;
		public JavaExpressionPeer.GivenArrayPatternPeer createGivenArray(int keywordLine, int keywordCharacter) ;
		public JavaExpressionPeer.ConstructorCallPatternPeer createConstructorCall(int keywordLine, int keywordCharacter) ;
		public JavaExpressionPeer.PrimitivePatternPeer createPrimitive() ;
		public void createThis(int keywordLine, int keywordCharacter) ;
		public void createNull(int keywordLine, int keywordCharacter) ;
		public void createMark(java.lang.String markName, int markNameLine, int markNameCharacter) ;
	}
	public static interface BinaryPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForLeft() ;
		public GeneralSymbolPatternPeer addGeneralSymbolForSymbol() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForRight() ;
	}
	public static interface GeneralBinaryPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForLeft() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForSymbol() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForRight() ;
	}
	public static interface PostUnaryPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
		public GeneralSymbolPatternPeer addGeneralSymbolForSymbol() ;
	}
	public static interface PreUnaryPatternPeer {
		public void end() ;
		public GeneralSymbolPatternPeer addGeneralSymbolForSymbol() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
	}
	public static interface AssignmentPatternPeer {
		public void end() ;
		public JavaCallChainPatternPeer addJavaCallChainForVariable() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
	}
	public static interface MappingVariableRefPatternPeer {
		public void end() ;
		public BuilderVariableChainPatternPeer addBuilderVariableChainForMappingChain() ;
		public BuilderVariableChainPatternPeer addBuilderVariableChainForSourceVariable() ;
	}
	public static interface CallPatternPeer {
		public void end() ;
		public JavaCallChainPatternPeer addJavaCallChainForValue() ;
	}
	public static interface BracketedPatternPeer {
		public void end() ;
		public JavaExpressionPeer.Indirect getJavaExpressionForValue() ;
	}
	public static interface BuilderVariableRefPatternPeer {
		public void end() ;
		public BuilderVariableChainPatternPeer addBuilderVariableChainForChain() ;
	}
	public static interface ArrayConstructorCallPatternPeer {
		public void end() ;
		public TargetTypeReferenceWithoutArrayPatternPeer addTargetTypeReferenceWithoutArrayForTypeName(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
		public JavaExpressionPeer.Indirect getJavaExpressionForDimensionExpression() ;
	}
	public static interface GivenArrayPatternPeer {
		public void end() ;
		public TargetTypeReferenceWithoutArrayPatternPeer addTargetTypeReferenceWithoutArrayForTypeName(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
		public TargetCallArgumentsPatternPeer addTargetCallArgumentsForValues() ;
	}
	public static interface ConstructorCallPatternPeer {
		public void end() ;
		public TargetTypeReferenceWithoutArrayPatternPeer addTargetTypeReferenceWithoutArrayForTypeName(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
		public TargetCallArgumentsPatternPeer addTargetCallArgumentsForArguments() ;
	}
	public static interface PrimitivePatternPeer {
		public void end() ;
		public void addCharValue(java.lang.String value, int lineNumber, int characterNumber) ;
		public void addString(java.lang.String value, int lineNumber, int characterNumber) ;
		public void addInteger(int value, int lineNumber, int characterNumber) ;
		public void addBooleanValue(boolean value, int lineNumber, int characterNumber) ;
	}
}
