package org.ffd2.skeletonx.compile.design;

import org.ffd2.solar.exceptions.ParsingException;

import org.ffd2.skeletonx.compile.impl.ChainImplementationTarget;
import org.ffd2.skeletonx.compile.java.ImplementationParameterTarget;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.ChainBlockFormHolder;
import org.ffd2.skeletonx.skeleton.ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock;
import org.ffd2.skeletonx.skeleton.DataBlockFormHolder;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock;
import org.ffd2.skeletonx.skeleton.TargetBaseFormHolder;

public interface DesignType  {
  public DesignType getDirectSubDesignType(String name) throws ParsingException;
  public LinkTypeDataBlock addChainLink(String linkName, ChainLinkSkeletonSource skeletonSource) throws ParsingException;
  
 
  public void updateParameter(ParameterSettingsFormHolder.ParameterSettingsFormBlock skeleton, String parameterName);
 // public void updateJavaParameter(BaseBuilder.JavaParameterSettingsFormBlock skeleton, String parameterName);

  public GivenParameterInstantiation createParameter(ParameterSettingsFormHolder.ParameterSettingsFormBlock targetDataSkeleton, String parameterName);
  
  
  public void createParameterType(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock targetDataSkeleton);
  public FixedValueAccess createFixed(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock targetDataSkeleton, String parameterName) throws ParsingException;

  //public FixedValueAccess updateAsFixedValue(BaseBuilder.ParameterSettingsTemplate skeleton, String parameterName) throws ParsingException;
  
  public void buildImplementationParameter(ImplementationParameterTarget target, String parameterName);
  public DesignType getAsArrayType() throws ParsingException;
  public void doAddChainLink(ChainImplementationTarget target, String linkName, int linkIndex);
  
  public String getNameForError();
  
  public interface GivenParameterInstantiation {
  	//This should really take as a value the requested design type and throw a parsing exception if cannot cast
  	// - currently types must exactly match
    public void requestRecordFromVariableFinal(IsFixedDataBlock fixedSkeleton, BaseTrackers.DesignVariablePath variablePath) throws ParsingException;

  }
  
  public static interface ChainLinkSkeletonSource {
  	public ChainBlockFormHolder.ChainBlockFormBlock getChainBlockSkeleton();
  	public TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock getLinkRefSkeleton();
  }
}
