package org.ffd2.skeletonx.compile.impl;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.JavaParameterSettingsFormHolder;
import org.ffd2.skeletonx.skeleton.KeyBuilderFormHolder.KeyBuilderFormBlock;
import org.ffd2.skeletonx.skeleton.MappingBuilderFormHolder;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder;
import org.ffd2.solar.language.SpecificCommonErrorOutput;

public class KeyDefinitionBlock {
	private final SpecificCommonErrorOutput	error_;
	private final KeyBuilderFormBlock	keyBuilderSkeleton_;
	private final String	keyName_;

	public KeyDefinitionBlock( String keyName, BaseBuilder baseBuilder, SpecificCommonErrorOutput error) {
		this.keyName_ = keyName;
		this.error_ = error;
		this.keyBuilderSkeleton_ = baseBuilder.createKeyBuilderChild(keyName);
	}
	public String getName() { return "Key:"+keyName_;}
	public void basicBuild(DesignBlock parent) {
		
	}
	public MappingBuilderFormHolder.MappingBuilderFormBlock createMapping(String mappingName,  BaseBuilder targetBaseBuilder) {
		return targetBaseBuilder.createMappingBuilderChild(mappingName, this.keyBuilderSkeleton_);
	}
	public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock addKeyParameter(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock target) {
		return target.addKey(this.keyBuilderSkeleton_);
	}
	public  JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock addKeyParameter(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock target) {
		return target.addKey(this.keyBuilderSkeleton_);
	}

	public void finalBuild() { }

}
