package org.ffd2.skeletonx.compile.java;

import org.ffd2.solar.general.SimpleVector;
import org.ffd2.solar.language.SpecificCommonErrorOutput;

import org.ffd2.skeletonx.austenx.peg.base.ChainHookListPatternPeer;

public class ChainHookListBlock implements ChainHookListPatternPeer {
	private SpecificCommonErrorOutput error_;
	private final SimpleVector<ChainLinkElement> linkElements_ = new SimpleVector<ChainLinkElement>();

	public ChainHookListBlock( SpecificCommonErrorOutput error) {
		this.error_ = error;
	}
	public void requestUpdate(BlockUser user) {
		for(ChainLinkElement e : linkElements_) {
			e.doInform(user);
		}
	}

	public void addChainHookElementForE(String chainNameParameter, String linkNameParameter,
			int linkNameLineNumber, int linkNameCharacterNumber) {
		SpecificCommonErrorOutput error = this.error_.createAdjusted(linkNameLineNumber, linkNameCharacterNumber);
		ChainLinkElement e = new ChainLinkElement(chainNameParameter,linkNameParameter, error);
		linkElements_.addElement(e);
	}

	public void end() { }
	//==============================================================================
	public static interface BlockUser {
		/**
		 * Notify of new link - called during intermediate pass
		 * @param chainName
		 * @param linkName
		 * @param error
		 */
		public void newLink(String chainName, String linkName, SpecificCommonErrorOutput error);
	}
	// ==============================================================================
	private final class ChainLinkElement {
		private final SpecificCommonErrorOutput linkError_;
		private final String linkNameParameter_;
		private final String chainNameParameter_;

		public ChainLinkElement(String chainNameParameter, String linkNameParameter, SpecificCommonErrorOutput error) {
			this.chainNameParameter_ = chainNameParameter;
			this.linkNameParameter_ = linkNameParameter;
			this.linkError_ = error;
		}
		public void doInform(BlockUser user) {
			user.newLink(this.chainNameParameter_, this.linkNameParameter_, this.linkError_);
		}
		
	}
}
