package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock;

import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.general.Debug;

public class DebugIRecordVariable implements IRecordVariable {
	private final IRecordVariable	base_;
	private final String	id_;

	public DebugIRecordVariable(IRecordVariable base, String id) {
		this.base_ = base;
		this.id_ = id;
		
	}
  @Override public boolean isMatchesVariableName(String queryVariableName) { 
		Debug.println("++++++++DEBUG  isMatchesVariable:",this.id_, "  (",queryVariableName,")");

  	return this.base_.isMatchesVariableName(queryVariableName); 
  }
	@Override public String getRoughVariableName() { 
		return	this.base_.getRoughVariableName();
	}
	public void getAsReference(IRecordTypeTarget target) {
		Debug.println("++++++++DEBUG getAsReference:",this.id_);
		this.base_.getAsReference(target);
	}
	
	public void updateNameBlock(NameDetailsFormBlock.ComplexDataBlock target, JavaVariablePath variablePath, NameBlockDetails elementDetails) throws ParsingException {
		Debug.println("++++++++DEBUG UPNB:",this.id_);

		base_.updateNameBlock(target, variablePath, elementDetails);
	}
	public void addAsMacroRecordMappingParameter( MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, MappingDefinitionBlock type) throws ParsingException {
		Debug.println("++++++++DEBUG AANRNO:",this.id_);

		base_.addAsMacroRecordMappingParameter(macroCallBlock, variablePath, type);
	}
	public void updateExpressionFinal(CodeBlockEnvironment environment, ExpressionDetailsFormBlock expressionSkeleton, JavaVariablePath variablePath) throws ParsingException {
		Debug.println("++++++++DEBUG UEF:",this.id_);
		base_.updateExpressionFinal(environment, expressionSkeleton, variablePath);
	}

	public void addAsMacroRecordParameter(MacroCallDataBlock macroCallBlock,JavaVariablePath variablePath, IVariableType type) throws ParsingException {
		Debug.println("++++++++DEBUG UAMRP:",this.id_);
		base_.addAsMacroRecordParameter(macroCallBlock, variablePath, type);
	}

	public void updateCallChainFinal(BasicCallChainFormBlock target, JavaVariablePath variablePathToThisVariable) throws ParsingException {
		Debug.println("++++++++DEBUG UCCF:",this.id_);
		base_.updateCallChainFinal(target, variablePathToThisVariable);
	}


	public SLayer getAsFoundataionNodeReferenceVariable( JavaVariablePath variablePath) throws ParsingException {
		Debug.println("++++++++DEBUG GAFNRV:",this.id_);
		return base_.getAsFoundataionNodeReferenceVariable(variablePath);
	}



	public void addAsMacroRecordKeyParameter(MacroCallDataBlock macroCallBlock,
			JavaVariablePath variablePath, KeyDefinitionBlock type)
			throws ParsingException {
		Debug.println("++++++++DEBUG AAMRKP:",this.id_);

		base_.addAsMacroRecordKeyParameter(macroCallBlock, variablePath, type);
	}
	public void addAsGeneralExpressionTargetRequirement(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath) throws ParsingException {
		Debug.println("++++++++DEBUG AAGETR:",this.id_);

		base_.addAsGeneralExpressionTargetRequirement(macroCallBlock, variablePath);		
	}


//	public void doVariableQueryMatch(SearchRecordDataBlock targetSkeleton,
//			IRecordVariable queryMatchValue, JavaVariablePath variablePathToQueryMatch)
//			throws ParsingException {
//		Debug.println("++++++++DEBUG DVQM:",this.id_);
//
//		base_.doVariableQueryMatch(targetSkeleton, queryMatchValue, variablePathToQueryMatch);
//		
//	}


}
