package org.ffd2.skeletonx.compile.java;

import org.ffd2.solar.general.SimpleVector;

import org.ffd2.skeletonx.compile.java.layer.SLayer;

public class GeneralRecordItemStore implements RecordItem {
  private final SimpleVector<RecordItem> elements_ = new SimpleVector<RecordItem>();
  public GeneralRecordItemStore() { }
  public String toString(){ return "RS:"+elements_; }
  /**
   * @return true if okay
   */
  public boolean basicBuild(SLayer containingLayer) {
    boolean okay = true;
    for(RecordItem e : this.elements_ ) {
      okay = e.basicBuild(containingLayer) & okay; //Ordered this way to avoid lazy evaluation
    }
    return okay;
  }
  public void finishBuild() {
    for(RecordItem e : this.elements_ ) {
      e.finishBuild();
    }
  }
  public final void addElement(RecordItem e) {
    this.elements_.addElement(e);
  }
}
