package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;

import org.ffd2.solar.exceptions.ParsingException;

public enum IVariableType {
	RecordReference {
		public String getName() { return "Record Reference"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}

	},
	CodeMarkReference {
		public String getName() { return "Code Mark"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}

	},
	
	ARGUMENT_VALUES_REFERENCE {
		public  String getName() { return "Argument Values Mark"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}

	},
	MAPPING_REFERENCE {
		public  String getName() { return "Mapping Mark"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}

	},
	KEY_REFERENCE {
		public  String getName() { return "Key Mark"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}

	},
	ArgumentTypesReference {
		public  String getName() { return "Argument Types Mark"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath, JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			target.addArgumentTypesReference(source.getVariableStoreParameter(), variablePath);
		}

	},
	ParametersReference {
		public  String getName() { return "Parameters Mark"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}
	},
	ExpressionReference {
		public  String getName() { return "Expression reference"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}
	},
	StringSource {
		public  String getName() { return "String source"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}
	},
	IntSource {
		public  String getName() { return "Int source"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}
	},
	ChainVariable{
		public  String getName() { return "Chain Variable"; }
		public void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source, BaseTrackers.JavaVariablePath variablePath,JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException {
			throw ParsingException.createInvalidType(ArgumentTypesReference.getName(), getName());
		}
	};
	public ParsingException createMismatchException(IVariableType otherType) {
		return ParsingException.createInvalidType(getName(), otherType.getName());
	}
	public abstract String getName();
	// ===== Future refactoring
	public abstract void addAsArgTypes(JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock.ArgTypesMarkDataBlock source,BaseTrackers.JavaVariablePath variablePath, JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock target) throws ParsingException;
}
