package org.ffd2.skeletonx.compile.java;

import org.ffd2.solar.general.SimpleStringBuffer;
import org.ffd2.solar.general.Source;


public class RecordVariableTrace {
	private final IRecordVariable[] links_;

	public RecordVariableTrace() {
		this.links_ = new IRecordVariable[0];
	}
	public RecordVariableTrace(Source<IRecordVariable> base) {
		this.links_ = new IRecordVariable[base.size()];
		base.copyInto(0, links_, 0, this.links_.length);
		
	}
	public boolean isEmptyTrace() {
		return this.links_.length==0;
	}
	public RecordVariableTrace(IRecordVariable[] base, IRecordVariable[] toAppend) {
		this.links_ = new IRecordVariable[base.length+toAppend.length];
		System.arraycopy(base,0,this.links_,0,base.length);
		System.arraycopy(toAppend,0,this.links_,base.length,toAppend.length);
		
	}
	private RecordVariableTrace(IRecordVariable[] base, IRecordVariable toAppend) {
		this.links_ = new IRecordVariable[base.length+1];
		System.arraycopy(base,0,this.links_,0,base.length);
		this.links_[base.length] = toAppend;
	}
	private RecordVariableTrace(IRecordVariable[] base, Source<IRecordVariable> toAppend) {
		this.links_ = new IRecordVariable[base.length+toAppend.size()];
		System.arraycopy(base,0,this.links_,0,base.length);
		toAppend.copyInto(0,this.links_,base.length,toAppend.size());
	}
	public RecordVariableTrace getAppended(IRecordVariable toAppend) {
		return new RecordVariableTrace(this.links_, toAppend);
	}
	public String toString() {
		SimpleStringBuffer buffer = new SimpleStringBuffer();
		buffer.append('[').appendArray(this.links_, ", ").append(']');
		return buffer.toString();
	}
//	public RecordVariableTrace getAppended(RecordVariableTrace toAppend) {
//		return new RecordVariableTrace(this.links_, toAppend.links_);
//	}
	public RecordVariableTrace getAppended(Source<IRecordVariable> toAppend) {
		return new RecordVariableTrace(this.links_, toAppend);
	}
	public static final RecordVariableTrace getEmptyTrace() {
		return new RecordVariableTrace();
	}
	public boolean isContains(RecordVariableTrace querySubSet) {
		if(querySubSet.isEmptyTrace()) {
			return true;
		}
		IRecordVariable[] otherLinks = querySubSet.links_;
		int otherIndex = otherLinks.length-1;
		for(int myIndex = this.links_.length-1 ; myIndex>=0 ; myIndex--) {
			if(links_[myIndex]==otherLinks[otherIndex]) {
				otherIndex--;
				if(otherIndex<0) {
					return true;
				}
			}
		}
		return false;
	}
}
