package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.java.layer.CodeBlockContainer;



public class ScopeContainer {
	private final ScopeContainer parent_;
	private final CodeBlockContainer relatedCodeBlock_;
	public ScopeContainer() {
		this(new CodeBlockContainer());
	}
	public ScopeContainer(CodeBlockContainer relatedCodeBlock) {
		this(relatedCodeBlock, null);
	}
	private ScopeContainer(CodeBlockContainer relatedCodeBlock, ScopeContainer parent) {
		this.parent_ = parent;
		this.relatedCodeBlock_ = relatedCodeBlock;
	}
	public CodeBlockContainer getRelatedCodeBlockContainer() {
		return this.relatedCodeBlock_;
	}
	public boolean isThisScopeChildOfTheQuery(ScopeContainer query) {
		if(query.relatedCodeBlock_==this.relatedCodeBlock_) {
			return isThisScopeTheChildOfTheQueryNoCodeBlockCheck(query);
		} else {
			return false;
		}
	}
	public ScopeContainer getChild() { return new ScopeContainer(this.relatedCodeBlock_,this); }
	
	private boolean isThisScopeTheChildOfTheQueryNoCodeBlockCheck(ScopeContainer query) {
		if(query==this) {
			return true;
		} else if(this.parent_!=null) {
			return this.parent_.isThisScopeTheChildOfTheQueryNoCodeBlockCheck(query);
		} else {
			return false;
		}
	}
	// ==========================================================================
  private static interface ScopeBacklink {
  	
  }
  private static abstract class AbstractBackLink implements ScopeBacklink {
  	private final ScopeBacklink	parent_;

		public AbstractBackLink(ScopeBacklink parent) {
			this.parent_ = parent;
  	}
		protected final ScopeBacklink getParent() {
			return this.parent_;
		}
  }
  private static final class RootBacklink implements ScopeBacklink {
  	
  }
  private static final class SubBlockBackLink extends AbstractBackLink implements ScopeBacklink {
  	public SubBlockBackLink(ScopeBacklink parent) {
  		super(parent);
  	}
  }
  private static final class VariableBacklink extends AbstractBackLink implements ScopeBacklink {
  	public VariableBacklink(ScopeBacklink parent) {
  		super(parent);
  	}
  }
}
