package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock;

import org.ffd2.solar.exceptions.ParsingException;

public class SpecificPurposeBuilderVariable implements IRecordVariable{
	private final Details	details_;
	public SpecificPurposeBuilderVariable(Details details) {
		this.details_ = details;
	}
	@Override public boolean isMatchesVariableName(String queryVariableName) { return false; }
	@Override public String getRoughVariableName() { return "???"; }
	public SLayer getAsFoundataionNodeReferenceVariable( JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot provide foundation record information");		
	}
	public void updateNameBlock(NameDetailsFormBlock.ComplexDataBlock target, JavaVariablePath variablePath, NameBlockDetails elementDetails) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot provide name block information");		
	}
	public void updateExpressionFinal(CodeBlockEnvironment environment, ExpressionDetailsFormBlock expressionSkeleton, JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot provide expression information");		
	}
	public void addAsMacroRecordMappingParameter( JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, MappingDefinitionBlock type) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot supply mappings");
	}
	public void addAsMacroRecordKeyParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock,
			JavaVariablePath variablePath, KeyDefinitionBlock type) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot supply keys");

	}

	
	public void addAsMacroRecordParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, IVariableType type) 	throws ParsingException {
		if(!details_.addAsMacroRecordParameter( macroCallBlock, variablePath, type)) {
			throw ParsingException.createGeneralSyntax("variable cannot provide macro parameter for "+type.getName());
		}
		
	}
	public void updateCallChainFinal(BasicCallChainFormBlock target, JavaVariablePath variablePathToThisVariable) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot provide chain information");
	}
	public void getAsReference(IRecordTypeTarget target) {
		details_.getAsReference(target);
	}
	
	
	// ==========================================================================
	public static  interface Details {
		public void getAsReference(IRecordTypeTarget target);
		
		/**
		 * @return false if not able to provide
		 */
		public boolean addAsMacroRecordParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, IVariableType type)throws ParsingException;
	
	}


	public void addAsGeneralExpressionTargetRequirement(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath) throws ParsingException {
		throw ParsingException.createGeneralSyntax("variable cannot supply expression targets");
		
	}
		
}
