package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.skeletonx.skeleton.TargetBaseFormHolder.TargetBaseFormBlock;

public final class AncestorConnection {
	private final FoundationNode	parentNode_;
	private final FoundationNodeChildReference	targetNode_;

	public AncestorConnection(FoundationNode parentNode, FoundationNodeChildReference targetNode) {
		this.parentNode_ = parentNode;
		this.targetNode_ = targetNode;
	}
	public FoundationNode getParentNode() { return parentNode_; }
	public FoundationNode getTargetNode() { return targetNode_.getChildNode(); }
	public ImplementationBlockSkeletonManager getTargetNodeSkeleton() {
		return targetNode_.getNodeSkeleton();
	}
	public TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock getChildRefInParentSkeleton() {
		return targetNode_.getChildRefInParentSkeleton();
	}
	public JavaImplementationFormBlock.BlockDataBlock.ChildRefDataBlock getImplementationChildRefInParentSkeleton() {
		return targetNode_.getImplementationChildRefInParentSkeleton();
	}
	
}