package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.solar.exceptions.ParsingException;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.java.CodeBlockEnvironment;
import org.ffd2.skeletonx.compile.java.IRecordTypeTarget;
import org.ffd2.skeletonx.compile.java.IRecordVariable.NameBlockDetails;
import org.ffd2.skeletonx.compile.java.IVariableType;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;

public interface BuilderVariableType {
  public SLayer getAsFoundataionNodeReferenceVariableForType(BaseTrackers.JavaVariablePath pathToExtend) throws ParsingException;

  public void getAsReference(IRecordTypeTarget target);

	
  public void updateNameBlock(ComplexDataBlock target, JavaVariablePath variablePath, NameBlockDetails elementDetails) throws ParsingException;
  public void updateCallChainFinal(BasicCallChainFormBlock target, JavaVariablePath variablePathToThisVariable) throws ParsingException;
  public void addAsMacroRecordParameter(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath,IVariableType type) throws ParsingException;
	public void addAsMacroRecordMappingParameter( MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, MappingDefinitionBlock type) throws ParsingException;
	public void addAsMacroRecordKeyParameter(MacroCallDataBlock macroCallBlock, JavaVariablePath variablePath, KeyDefinitionBlock type)throws ParsingException;
  public void updateExpressionFinal(CodeBlockEnvironment environment, ExpressionDetailsFormBlock expressionSkeleton, JavaVariablePath variablePath) throws ParsingException;
}