package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.solar.general.Debug;


public class NodeLayerChild {
	private final String	name_;
	private final SLayer	childLayer_;
//	private final ChildType childType_;
	private final Type type_; 
	private NodeLayerChild(String name,SLayer childLayer, Type type) {
		this.name_ = name;
		this.type_ = type;
	//	this.childType_ =  childType;
		this.childLayer_ = childLayer;
	}
	public static final NodeLayerChild createLocalChild(final String name, SLayer childLayer,final LocalChild childRefInfo) {
		
		return new NodeLayerChild(name, childLayer, new Type() {
			public String toString(){
				return "Local child type:"+name;
			}
			public void doAddAncestorTypeSearch(JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock target, BaseTrackers.JavaVariablePath pathToParentLayer) {
				childRefInfo.doAddAncestorTypeSearch(target, pathToParentLayer);
			}
		});
	}
	public static final NodeLayerChild createFoundationNodeChild(final String name, SLayer childLayer, final FoundationNodeChildReference childRefInfo) {
		return new NodeLayerChild(name, childLayer, new Type() {
			public String toString(){
				return "Foundation child type:"+name;
			}
			public void doAddAncestorTypeSearch(JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock target, BaseTrackers.JavaVariablePath pathToParentLayer) {
				childRefInfo.doAddAncestorTypeSearch(target, pathToParentLayer);
			}
		});
	}
	public void doAddAncestorTypeSearch(JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock target, BaseTrackers.JavaVariablePath pathToParentLayer) {
		this.type_.doAddAncestorTypeSearch(target, pathToParentLayer);
	}

  public SLayer getBase() { return childLayer_; }
  private static interface Type {
		public void doAddAncestorTypeSearch(JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock target, BaseTrackers.JavaVariablePath pathToParentLayer);
  }
//	public static final NodeLayerChild createFoundationLayerChild(String name, FoundationNode peerFoundationNode, SLayer peerLayer,FoundationNodeChildReference childNodeReferenceInParent) {
//		return new NodeLayerChild(name, peerLayer, new FoundationChildType(peerFoundationNode,peerLayer, childNodeReferenceInParent));
//	}
//	public static final NodeLayerChild createNonFoundationLayerChild(String name, SLayer childLayer) {
//		return new NodeLayerChild(name, childLayer, NonFoundationChildType.INSTANCE); //Non-foundation by default - until instructed otherwise (by FoundationNode setup stuff)
//		
//	}
//	/**
//	 * Set up child as Foundation Layer of a parent Foundation Layer
//	 * @param childNode the related FoundationNode
//	 */
//	public void setAsFoundationLink(FoundationNode childNode,FoundationNodeChildReference childNodeReferenceInParent) {
//		this.childType_ = new FoundationChildType(childNode,childNodeReferenceInParent);
//	}
//	public void basicBuildFromFoundationLayerParent(LinkupTracker nodeBuilder, SLayer parentLayer, ImplementationBlockSkeletonManager parentBlockSkeleton, FoundationNode parentFoundationNode) {
//		this.childType_.basicBuildFromFoundationLayerParent(nodeBuilder, parentLayer, parentBlockSkeleton, parentFoundationNode, this);
//	}
//	public void basicBuildFromNonFoundationParent(LinkupTracker nodeBuilder, SLayer parentLayer, ImplementationBlockSkeletonManager parentBlockSkeleton) {
//		this.childType_.basicBuildFromNonFoundationLayerParent(nodeBuilder, parentLayer, parentBlockSkeleton, this);
//	}
	// ==========================================================================
//	private static interface ChildType {
//		public void basicBuildFromFoundationLayerParent(
//				LinkupTracker nodeBuilder, 
//				SLayer parentLayer, 
//				ImplementationBlockSkeletonManager parentBlockSkeleton, 
//				FoundationNode parentFoundationNode, 
//				NodeLayerChild parent
//				);
//		public void basicBuildFromNonFoundationLayerParent(
//				LinkupTracker nodeBuilder, 
//				SLayer parentLayer, 
//				ImplementationBlockSkeletonManager parentBlockSkeleton, 
//				NodeLayerChild parent
//				);
//	}
	// -------------------------------------------------------------------------
//	private static final class FoundationChildType implements ChildType {
//		private FoundationNode peerFoundationNode_;
//		private final FoundationNodeChildReference	childNodeReferenceInParent_; 
//		public FoundationChildType(FoundationNode peerFoundationNode, SLayer peerLayer,FoundationNodeChildReference childNodeReferenceInParent) {
//			this.peerFoundationNode_ = peerFoundationNode;
//			this.childNodeReferenceInParent_ = childNodeReferenceInParent;
//		}
//		
////		public void basicBuildFromFoundationLayerParent(
////				LinkupTracker nodeBuilder, 
////				SLayer parentLayer, 
////				ImplementationBlockSkeletonManager parentBlockSkeleton, FoundationNode parentFoundationNode, 
////				NodeLayerChild parent) {
////		//To know our FoundationNode already means this child is a layer of the Foundation structure
////			FoundationLayerType bridge = new FoundationLayerType(parentLayer, parent.childLayer_,parentFoundationNode,this.peerFoundationNode_,this.childNodeReferenceInParent_);
////			parent.childLayer_.basicBuild(
////					bridge,this.peerFoundationNode_.getSkeletonManager(),nodeBuilder
////			);
////		}
//	}
//	
//	private static final class NonFoundationChildType implements ChildType {
//		public static final NonFoundationChildType INSTANCE = new NonFoundationChildType();
//		
////		public void basicBuildFromFoundationLayerParent(
////				LinkupTracker nodeBuilder, 
////				SLayer parentLayer, 
////				ImplementationBlockSkeletonManager parentBlockSkeleton, 
////				FoundationNode parentFoundationNode, 
////				NodeLayerChild parent
////				) {
////			basicBuildBase(nodeBuilder, parentLayer, parentBlockSkeleton, parent);
////		}
////		
////		public void basicBuildFromNonFoundationLayerParent(
////				LinkupTracker nodeBuilder, 
////				SLayer parentLayer, 
////				ImplementationBlockSkeletonManager parentBlockSkeleton, 
////				NodeLayerChild parent
////				) {
////			basicBuildBase(nodeBuilder, parentLayer, parentBlockSkeleton, parent);
////		}
////		
////		public void basicBuildBase(
////				LinkupTracker nodeBuilder, 
////				SLayer parentLayer, 
////				ImplementationBlockSkeletonManager parentBlockSkeleton, 
////				NodeLayerChild parent
////				) {
////			BaseTrackers.JavaVariablePath path = new BaseTrackers.JavaVariablePath();
////			final String name = parent.name_;
////			final SLayer childLayer = parent.childLayer_;
////			AncestorConnection ancestor = parentLayer.getAncestorFoundationNodeQuiet(name, path,true);
////			if(ancestor==null) {
////				parent.requestErrors_.objectNotFoundError("node child", name);
////			} else {
////				FoundationNode peerFoundationNode = ancestor.getTargetNode();
////				
////				LocalChild childRef = parentBlockSkeleton.createLocalChild(name, childLayer, nodeBuilder, ancestor,path);
////				DualIndirectLayerType bridge = DualIndirectLayerType.buildLocalNodeChildBased(childLayer, childRef, peerFoundationNode, parentLayer);
////				childLayer.basicBuild(
////						bridge,childRef.getSkeletonManager(),nodeBuilder
////					);
////				
////			}
////		}
//	}
////	/**
////	 * Build remaining skeletons and link everything up  - report errors for 
////	 * unknown blocks/variables
////	 * @param relatedTracker the tracker which should now have it's Container linkup array settled.
////	 * @param isTopLevel if true we are at a node that has no variable redirections
////	 */
////	public void basicBuild(LinkupTracker relatedTracker, SLayer parent) {
////		if(this.designLinkedBlockSkeleton_==null) {
////			this.requestErrors_.objectNotFoundError("Design Block", this.name_);
////			//No, should check parent
////		}
//////		if(isTopLevel) {
//////			
//////		} else {
//////			BlockDataBlock mySkeleton = relatedTracker.allocateSpareBlock(name_+"Local");
//////			baseContainer_.setBlockSkeleton(mySkeleton);
//////		}
////		baseContainer_.basicBuild(relatedTracker);
////	}
//	
////	private void setupRecordBaseReferences(LinkupTracker relatedTracker,DesignRecordReference reference, TargetBaseForm.BlockDataBlock.ChildRefDataBlock childRefInParent) {
////		this.reference_ = reference;
////		this.childRefInParent_ = childRefInParent;
////		designLinkedBlockSkeleton_ = relatedTracker.instantiateRecordContainer(reference, this.baseContainer_);
////		//This will change with the new SkeletonX, as the main skeleton can then be built a priori...
////		baseContainer_.setBlockSkeleton(this.designLinkedBlockSkeleton_.getParent());
////	}

} //End of class Recordhild