package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.impl.FileEnvironment;
import org.ffd2.skeletonx.compile.java.IRecordVariable;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.general.Debug;


public class VariableChild  {
	
	private final SLayer baseLayer_;
	private final String name_;
	private final IRecordVariable	referencingVariable_;
	private final JavaVariablePath	pathToVariableInBase_;
	public VariableChild(String name, SLayer baseContainer, IRecordVariable referencingVariable, FileEnvironment fileEnvironment, BaseTrackers.JavaVariablePath pathToVariableInBase) {
		this.name_ = name;
		this.baseLayer_ = baseContainer;
		this.referencingVariable_ = referencingVariable;
		this.pathToVariableInBase_ = pathToVariableInBase;		
	}
	public IRecordVariable getReferencingVariable() {
		return this.referencingVariable_;
	}
	public  BaseTrackers.JavaVariablePath getPathToVariableInBase() {
		return this.pathToVariableInBase_.getCopy();
	}
	public void  transferPathToVariableInBaseTo( BaseTrackers.JavaVariablePath target) {
		this.pathToVariableInBase_.transferTo(target);
	}
	public SLayer getBase() { return baseLayer_; }
} //End of class VariableChild