package org.ffd2.skeletonx.austenx.lexi.tokens;
public final class SkeletonTable implements SkeletonUser {
	private final org.ffd2.solar.general.SimpleVector<SkeletonToken> tableStore_;
	private final int[] marks_;
	public SkeletonTable() {
		tableStore_ = new org.ffd2.solar.general.SimpleVector<SkeletonToken>();
		marks_ = new int[0];
	}
	public SkeletonTable(org.ffd2.solar.general.SimpleVector<SkeletonToken> target) {
		tableStore_ = target;
		marks_ = new int[0];
	}
	public final void markToken(int markIndex) {
		marks_[markIndex] = tableStore_.size();
	}
	public final void reverseTokens(int startToken) {
		tableStore_.reverseOrderOfElements(startToken);
	}
	public final int getMarkToken(int markIndex) {
		return marks_[markIndex];
	}
	public final org.ffd2.solar.general.SimpleVector<SkeletonToken> getTokens() {
		return tableStore_;
	}
	public final java.lang.String toString() {
		return "Skeleton" + " token table for " + "Skeleton" + " " + tableStore_;
	}
	public final void reset() {
		tableStore_.removeAllElements();
	}
	public final void tokenOUTPUT_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.OUTPUT_KEYWORDTokenImpl token = new SkeletonTable.OUTPUT_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenDESIGN_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.DESIGN_KEYWORDTokenImpl token = new SkeletonTable.DESIGN_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenTEMPLATE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.TEMPLATE_KEYWORDTokenImpl token = new SkeletonTable.TEMPLATE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenJAVA_KEYWORD(java.lang.String value, int lineNumber, int characterNumber) {
		SkeletonTable.JAVA_KEYWORDTokenImpl token = new SkeletonTable.JAVA_KEYWORDTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenJAVA_KEYWORD_1(int lineNumber, int characterNumber) {
		SkeletonTable.JAVA_KEYWORDTokenImpl_1 token = new SkeletonTable.JAVA_KEYWORDTokenImpl_1(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenEXTERNAL_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.EXTERNAL_KEYWORDTokenImpl token = new SkeletonTable.EXTERNAL_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenIMPORT_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.IMPORT_KEYWORDTokenImpl token = new SkeletonTable.IMPORT_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenPUBLIC_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.PUBLIC_KEYWORDTokenImpl token = new SkeletonTable.PUBLIC_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenPACKAGE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.PACKAGE_KEYWORDTokenImpl token = new SkeletonTable.PACKAGE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenPRIVATE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.PRIVATE_KEYWORDTokenImpl token = new SkeletonTable.PRIVATE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenEXTENDS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.EXTENDS_KEYWORDTokenImpl token = new SkeletonTable.EXTENDS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenIMPLEMENTS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.IMPLEMENTS_KEYWORDTokenImpl token = new SkeletonTable.IMPLEMENTS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCLASS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.CLASS_KEYWORDTokenImpl token = new SkeletonTable.CLASS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenINTERFACE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.INTERFACE_KEYWORDTokenImpl token = new SkeletonTable.INTERFACE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenNEW_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.NEW_KEYWORDTokenImpl token = new SkeletonTable.NEW_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenTHIS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.THIS_KEYWORDTokenImpl token = new SkeletonTable.THIS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenNULL_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.NULL_KEYWORDTokenImpl token = new SkeletonTable.NULL_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSTATIC_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.STATIC_KEYWORDTokenImpl token = new SkeletonTable.STATIC_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFINAL_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.FINAL_KEYWORDTokenImpl token = new SkeletonTable.FINAL_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenTHROWS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.THROWS_KEYWORDTokenImpl token = new SkeletonTable.THROWS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenTHROW_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.THROW_KEYWORDTokenImpl token = new SkeletonTable.THROW_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSYNCHRONIZED_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.SYNCHRONIZED_KEYWORDTokenImpl token = new SkeletonTable.SYNCHRONIZED_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenIF_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.IF_KEYWORDTokenImpl token = new SkeletonTable.IF_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenELSE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.ELSE_KEYWORDTokenImpl token = new SkeletonTable.ELSE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRETURN_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.RETURN_KEYWORDTokenImpl token = new SkeletonTable.RETURN_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFOR_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.FOR_KEYWORDTokenImpl token = new SkeletonTable.FOR_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenWHILE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.WHILE_KEYWORDTokenImpl token = new SkeletonTable.WHILE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenDEPENDENT_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.DEPENDENT_KEYWORDTokenImpl token = new SkeletonTable.DEPENDENT_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenNOTE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.NOTE_KEYWORDTokenImpl token = new SkeletonTable.NOTE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSKELETON_IF_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.SKELETON_IF_KEYWORDTokenImpl token = new SkeletonTable.SKELETON_IF_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLINK_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.LINK_KEYWORDTokenImpl token = new SkeletonTable.LINK_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCHAIN_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.CHAIN_KEYWORDTokenImpl token = new SkeletonTable.CHAIN_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCONSTRUCTOR_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.CONSTRUCTOR_KEYWORDTokenImpl token = new SkeletonTable.CONSTRUCTOR_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenINCLUDE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.INCLUDE_KEYWORDTokenImpl token = new SkeletonTable.INCLUDE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenEXPRESSION_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.EXPRESSION_KEYWORDTokenImpl token = new SkeletonTable.EXPRESSION_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSTATEMENT_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.STATEMENT_KEYWORDTokenImpl token = new SkeletonTable.STATEMENT_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenGLOBAL_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.GLOBAL_KEYWORDTokenImpl token = new SkeletonTable.GLOBAL_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenMAPPING_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.MAPPING_KEYWORDTokenImpl token = new SkeletonTable.MAPPING_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenKEY_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.KEY_KEYWORDTokenImpl token = new SkeletonTable.KEY_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenMACRO_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.MACRO_KEYWORDTokenImpl token = new SkeletonTable.MACRO_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenMARK_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.MARK_KEYWORDTokenImpl token = new SkeletonTable.MARK_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFIND_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.FIND_KEYWORDTokenImpl token = new SkeletonTable.FIND_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFROM_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.FROM_KEYWORDTokenImpl token = new SkeletonTable.FROM_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSETS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.SETS_KEYWORDTokenImpl token = new SkeletonTable.SETS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSET_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.SET_KEYWORDTokenImpl token = new SkeletonTable.SET_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCODE_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.CODE_KEYWORDTokenImpl token = new SkeletonTable.CODE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSKELETON_CLASS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.SKELETON_CLASS_KEYWORDTokenImpl token = new SkeletonTable.SKELETON_CLASS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCONTAINER_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.CONTAINER_KEYWORDTokenImpl token = new SkeletonTable.CONTAINER_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenVAR_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.VAR_KEYWORDTokenImpl token = new SkeletonTable.VAR_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenTARGET_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.TARGET_KEYWORDTokenImpl token = new SkeletonTable.TARGET_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenARGVALS_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.ARGVALS_KEYWORDTokenImpl token = new SkeletonTable.ARGVALS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenARGTYPES_KEYWORD(int lineNumber, int characterNumber) {
		SkeletonTable.ARGTYPES_KEYWORDTokenImpl token = new SkeletonTable.ARGTYPES_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenBOOLEAN_VALUE(int lineNumber, int characterNumber) {
		SkeletonTable.BOOLEAN_VALUETokenImpl token = new SkeletonTable.BOOLEAN_VALUETokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenBOOLEAN_VALUE_1(int lineNumber, int characterNumber) {
		SkeletonTable.BOOLEAN_VALUETokenImpl_1 token = new SkeletonTable.BOOLEAN_VALUETokenImpl_1(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenMAP_TO_RIGHT_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.MAP_TO_RIGHT_SYMBOLTokenImpl token = new SkeletonTable.MAP_TO_RIGHT_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLEFT_TRIANGLE(int lineNumber, int characterNumber) {
		SkeletonTable.LEFT_TRIANGLETokenImpl token = new SkeletonTable.LEFT_TRIANGLETokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRIGHT_TRIANGLE(int lineNumber, int characterNumber) {
		SkeletonTable.RIGHT_TRIANGLETokenImpl token = new SkeletonTable.RIGHT_TRIANGLETokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLEFT_SQUARE(int lineNumber, int characterNumber) {
		SkeletonTable.LEFT_SQUARETokenImpl token = new SkeletonTable.LEFT_SQUARETokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRIGHT_SQUARE(int lineNumber, int characterNumber) {
		SkeletonTable.RIGHT_SQUARETokenImpl token = new SkeletonTable.RIGHT_SQUARETokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenGENERAL_BINARY_START(int lineNumber, int characterNumber) {
		SkeletonTable.GENERAL_BINARY_STARTTokenImpl token = new SkeletonTable.GENERAL_BINARY_STARTTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenGENERAL_BINARY_END(int lineNumber, int characterNumber) {
		SkeletonTable.GENERAL_BINARY_ENDTokenImpl token = new SkeletonTable.GENERAL_BINARY_ENDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenOTHER_JAVA_SYMBOL(java.lang.String value, int lineNumber, int characterNumber) {
		SkeletonTable.OTHER_JAVA_SYMBOLTokenImpl token = new SkeletonTable.OTHER_JAVA_SYMBOLTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenEXCLAMATION_MARK_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.EXCLAMATION_MARK_SYMBOLTokenImpl token = new SkeletonTable.EXCLAMATION_MARK_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenAMPERSAND_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.AMPERSAND_SYMBOLTokenImpl token = new SkeletonTable.AMPERSAND_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenAT_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.AT_SYMBOLTokenImpl token = new SkeletonTable.AT_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFULL_STOP_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.FULL_STOP_SYMBOLTokenImpl token = new SkeletonTable.FULL_STOP_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLEFT_CURLY(int lineNumber, int characterNumber) {
		SkeletonTable.LEFT_CURLYTokenImpl token = new SkeletonTable.LEFT_CURLYTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRIGHT_CURLY(int lineNumber, int characterNumber) {
		SkeletonTable.RIGHT_CURLYTokenImpl token = new SkeletonTable.RIGHT_CURLYTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLEFT_ROUND(int lineNumber, int characterNumber) {
		SkeletonTable.LEFT_ROUNDTokenImpl token = new SkeletonTable.LEFT_ROUNDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRIGHT_ROUND(int lineNumber, int characterNumber) {
		SkeletonTable.RIGHT_ROUNDTokenImpl token = new SkeletonTable.RIGHT_ROUNDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSEMI_COLON_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.SEMI_COLON_SYMBOLTokenImpl token = new SkeletonTable.SEMI_COLON_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCOLON(int lineNumber, int characterNumber) {
		SkeletonTable.COLONTokenImpl token = new SkeletonTable.COLONTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenOR_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.OR_SYMBOLTokenImpl token = new SkeletonTable.OR_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenMINUS_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.MINUS_SYMBOLTokenImpl token = new SkeletonTable.MINUS_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenDOLLAR_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.DOLLAR_SYMBOLTokenImpl token = new SkeletonTable.DOLLAR_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCOMMA_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.COMMA_SYMBOLTokenImpl token = new SkeletonTable.COMMA_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenASSIGNMENT(int lineNumber, int characterNumber) {
		SkeletonTable.ASSIGNMENTTokenImpl token = new SkeletonTable.ASSIGNMENTTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenQUESTION_MARK_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.QUESTION_MARK_SYMBOLTokenImpl token = new SkeletonTable.QUESTION_MARK_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenPLUS_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.PLUS_SYMBOLTokenImpl token = new SkeletonTable.PLUS_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSTAR_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.STAR_SYMBOLTokenImpl token = new SkeletonTable.STAR_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSLASH_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.SLASH_SYMBOLTokenImpl token = new SkeletonTable.SLASH_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenESCAPE_SYMBOL(int lineNumber, int characterNumber) {
		SkeletonTable.ESCAPE_SYMBOLTokenImpl token = new SkeletonTable.ESCAPE_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSTRING(java.lang.String value, int lineNumber, int characterNumber) {
		SkeletonTable.STRINGTokenImpl token = new SkeletonTable.STRINGTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCHAR(java.lang.String value, int lineNumber, int characterNumber) {
		SkeletonTable.CHARTokenImpl token = new SkeletonTable.CHARTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCHAR_1(java.lang.String value, int lineNumber, int characterNumber) {
		SkeletonTable.CHARTokenImpl_1 token = new SkeletonTable.CHARTokenImpl_1(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenID(java.lang.String value, int lineNumber, int characterNumber) {
		SkeletonTable.IDTokenImpl token = new SkeletonTable.IDTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenDOUBLE(double value, int lineNumber, int characterNumber) {
		SkeletonTable.DOUBLETokenImpl token = new SkeletonTable.DOUBLETokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenINTEGER(int value, int lineNumber, int characterNumber) {
		SkeletonTable.INTEGERTokenImpl token = new SkeletonTable.INTEGERTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public static final class OUTPUT_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public OUTPUT_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "output";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "OUTPUT_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return true;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class DESIGN_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public DESIGN_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "design";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "DESIGN_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return true;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class TEMPLATE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public TEMPLATE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "template";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "TEMPLATE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return true;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class JAVA_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public JAVA_KEYWORDTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "JAVA_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return true;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class JAVA_KEYWORDTokenImpl_1 implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public JAVA_KEYWORDTokenImpl_1(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "java";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "JAVA_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return true;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class EXTERNAL_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public EXTERNAL_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "external";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "EXTERNAL_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return true;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class IMPORT_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public IMPORT_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "IMPORT_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return true;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class PUBLIC_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public PUBLIC_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "PUBLIC_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return true;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class PACKAGE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public PACKAGE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "PACKAGE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return true;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class PRIVATE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public PRIVATE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "PRIVATE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return true;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class EXTENDS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public EXTENDS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "EXTENDS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return true;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class IMPLEMENTS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public IMPLEMENTS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "IMPLEMENTS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return true;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CLASS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public CLASS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CLASS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return true;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class INTERFACE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public INTERFACE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "INTERFACE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return true;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class NEW_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public NEW_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "new";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "NEW_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return true;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class THIS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public THIS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "this";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "THIS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return true;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class NULL_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public NULL_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "null";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "NULL_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return true;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class STATIC_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public STATIC_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "static";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "STATIC_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FINAL_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FINAL_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "final";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FINAL_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return true;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class THROWS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public THROWS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "throws";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "THROWS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return true;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class THROW_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public THROW_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "throw";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "THROW_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return true;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SYNCHRONIZED_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SYNCHRONIZED_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "synchronized";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SYNCHRONIZED_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return true;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class IF_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public IF_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "if";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "IF_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return true;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ELSE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ELSE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "else";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ELSE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return true;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RETURN_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RETURN_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "return";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RETURN_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return true;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FOR_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FOR_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "for";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FOR_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return true;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class WHILE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public WHILE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "while";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "WHILE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return true;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class DEPENDENT_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public DEPENDENT_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "dependent";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "DEPENDENT_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return true;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class NOTE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public NOTE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "@note";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "NOTE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return true;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SKELETON_IF_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SKELETON_IF_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "@if";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SKELETON_IF_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return true;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LINK_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LINK_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LINK_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return true;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CHAIN_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public CHAIN_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CHAIN_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return true;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CONSTRUCTOR_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public CONSTRUCTOR_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CONSTRUCTOR_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return true;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class INCLUDE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public INCLUDE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "INCLUDE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return true;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class EXPRESSION_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public EXPRESSION_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "EXPRESSION_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return true;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class STATEMENT_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public STATEMENT_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "STATEMENT_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return true;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class GLOBAL_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public GLOBAL_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "GLOBAL_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return true;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class MAPPING_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public MAPPING_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "MAPPING_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return true;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class KEY_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public KEY_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "KEY_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return true;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class MACRO_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public MACRO_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "MACRO_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return true;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class MARK_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public MARK_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "MARK_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return true;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FIND_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FIND_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FIND_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return true;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FROM_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FROM_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FROM_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return true;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SETS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SETS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SETS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return true;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SET_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SET_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SET_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return true;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CODE_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public CODE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CODE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return true;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SKELETON_CLASS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SKELETON_CLASS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SKELETON_CLASS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return true;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CONTAINER_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public CONTAINER_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CONTAINER_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return true;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class VAR_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public VAR_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "VAR_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return true;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class TARGET_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public TARGET_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "TARGET_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return true;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ARGVALS_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ARGVALS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ARGVALS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return true;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ARGTYPES_KEYWORDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ARGTYPES_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ARGTYPES_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return true;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class BOOLEAN_VALUETokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public BOOLEAN_VALUETokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(true);
		}
		public final boolean getBooleanValue() {
			return true;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "BOOLEAN_VALUE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return true;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class BOOLEAN_VALUETokenImpl_1 implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public BOOLEAN_VALUETokenImpl_1(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(false);
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "BOOLEAN_VALUE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return true;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class MAP_TO_RIGHT_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public MAP_TO_RIGHT_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "->";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "MAP_TO_RIGHT_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return true;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LEFT_TRIANGLETokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LEFT_TRIANGLETokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "<";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LEFT_TRIANGLE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return true;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RIGHT_TRIANGLETokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RIGHT_TRIANGLETokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ">";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RIGHT_TRIANGLE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return true;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LEFT_SQUARETokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LEFT_SQUARETokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "[";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LEFT_SQUARE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return true;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RIGHT_SQUARETokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RIGHT_SQUARETokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "]";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RIGHT_SQUARE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return true;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class GENERAL_BINARY_STARTTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public GENERAL_BINARY_STARTTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "|[";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "GENERAL_BINARY_START" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return true;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class GENERAL_BINARY_ENDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public GENERAL_BINARY_ENDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "]|";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "GENERAL_BINARY_END" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return true;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class OTHER_JAVA_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public OTHER_JAVA_SYMBOLTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "OTHER_JAVA_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return true;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class EXCLAMATION_MARK_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public EXCLAMATION_MARK_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "!";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "EXCLAMATION_MARK_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return true;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class AMPERSAND_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public AMPERSAND_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "&";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "AMPERSAND_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return true;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return true;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class AT_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public AT_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "@";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "AT_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return true;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FULL_STOP_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FULL_STOP_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ".";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FULL_STOP_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return true;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LEFT_CURLYTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LEFT_CURLYTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "{";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LEFT_CURLY" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return true;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RIGHT_CURLYTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RIGHT_CURLYTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "}";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RIGHT_CURLY" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return true;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LEFT_ROUNDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LEFT_ROUNDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "(";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LEFT_ROUND" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return true;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RIGHT_ROUNDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RIGHT_ROUNDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ")";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RIGHT_ROUND" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return true;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SEMI_COLON_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SEMI_COLON_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ";";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SEMI_COLON_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return true;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class COLONTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public COLONTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ":";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "COLON" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return true;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class OR_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public OR_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "|";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "OR_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return true;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return true;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class MINUS_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public MINUS_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "-";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "MINUS_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return true;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return true;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class DOLLAR_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public DOLLAR_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "DOLLAR_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return true;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class COMMA_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public COMMA_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "COMMA_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return true;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ASSIGNMENTTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ASSIGNMENTTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "=";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ASSIGNMENT" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return true;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class QUESTION_MARK_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public QUESTION_MARK_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "?";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "QUESTION_MARK_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return true;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class PLUS_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public PLUS_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "+";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "PLUS_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return true;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return true;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class STAR_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public STAR_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "*";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "STAR_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return true;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return true;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SLASH_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SLASH_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SLASH_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return true;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ESCAPE_SYMBOLTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ESCAPE_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ESCAPE_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return true;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class STRINGTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public STRINGTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "STRING" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return true;
		}
	}
	public static final class CHARTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public CHARTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CHAR" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return true;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CHARTokenImpl_1 implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public CHARTokenImpl_1(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CHAR" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return true;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class IDTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public IDTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ID" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class DOUBLETokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final double value_;
		public DOUBLETokenImpl(double value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(value_);
		}
		public final boolean getBooleanValue() {
			return value_ > 0;
		}
		public final double getDoubleValue() {
			return value_;
		}
		public final java.lang.String toString() {
			return "DOUBLE" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return true;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return false;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class INTEGERTokenImpl implements SkeletonToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final int value_;
		public INTEGERTokenImpl(int value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return value_;
		}
		public final long getLongValue() {
			return value_;
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(value_);
		}
		public final boolean getBooleanValue() {
			return value_ > 0;
		}
		public final double getDoubleValue() {
			return value_;
		}
		public final java.lang.String toString() {
			return "INTEGER" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isRIGHT_SQUARE() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isDEPENDENT_KEYWORD() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isLINK_KEYWORD() {
			return false;
		}
		public final boolean isWHILE_KEYWORD() {
			return false;
		}
		public final boolean isNULL_KEYWORD() {
			return false;
		}
		public final boolean isOPERATION_SYMBOL() {
			return false;
		}
		public final boolean isTHROW_KEYWORD() {
			return false;
		}
		public final boolean isDESIGN_KEYWORD() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isCHAR() {
			return false;
		}
		public final boolean isEXPRESSION_KEYWORD() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isPUBLIC_KEYWORD() {
			return false;
		}
		public final boolean isSKELETON_IF_KEYWORD() {
			return false;
		}
		public final boolean isARGVALS_KEYWORD() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isBOOLEAN_VALUE() {
			return false;
		}
		public final boolean isFOR_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_TRIANGLE() {
			return false;
		}
		public final boolean isEXTERNAL_KEYWORD() {
			return false;
		}
		public final boolean isOTHER_JAVA_SYMBOL() {
			return false;
		}
		public final boolean isCONTAINER_KEYWORD() {
			return false;
		}
		public final boolean isSTATEMENT_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_TRIANGLE() {
			return false;
		}
		public final boolean isSYNCHRONIZED_KEYWORD() {
			return false;
		}
		public final boolean isCONSTRUCTOR_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isIMPORT_KEYWORD() {
			return false;
		}
		public final boolean isSETS_KEYWORD() {
			return false;
		}
		public final boolean isDOUBLE() {
			return false;
		}
		public final boolean isNEW_KEYWORD() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFINAL_KEYWORD() {
			return false;
		}
		public final boolean isSET_KEYWORD() {
			return false;
		}
		public final boolean isFIND_KEYWORD() {
			return false;
		}
		public final boolean isINTEGER() {
			return true;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isGLOBAL_KEYWORD() {
			return false;
		}
		public final boolean isTHIS_KEYWORD() {
			return false;
		}
		public final boolean isOUTPUT_KEYWORD() {
			return false;
		}
		public final boolean isMARK_KEYWORD() {
			return false;
		}
		public final boolean isCHAIN_KEYWORD() {
			return false;
		}
		public final boolean isRETURN_KEYWORD() {
			return false;
		}
		public final boolean isTHROWS_KEYWORD() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isTARGET_KEYWORD() {
			return false;
		}
		public final boolean isEXTENDS_KEYWORD() {
			return false;
		}
		public final boolean isINTERFACE_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isIMPLEMENTS_KEYWORD() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isNOTE_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_START() {
			return false;
		}
		public final boolean isKEY_KEYWORD() {
			return false;
		}
		public final boolean isSTATIC_KEYWORD() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isMAP_TO_RIGHT_SYMBOL() {
			return false;
		}
		public final boolean isINCLUDE_KEYWORD() {
			return false;
		}
		public final boolean isVAR_KEYWORD() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isPACKAGE_KEYWORD() {
			return false;
		}
		public final boolean isMACRO_KEYWORD() {
			return false;
		}
		public final boolean isGENERAL_BINARY_END() {
			return false;
		}
		public final boolean isMAPPING_KEYWORD() {
			return false;
		}
		public final boolean isPRIVATE_KEYWORD() {
			return false;
		}
		public final boolean isASSIGNMENT() {
			return false;
		}
		public final boolean isSKELETON_CLASS_KEYWORD() {
			return false;
		}
		public final boolean isTEMPLATE_KEYWORD() {
			return false;
		}
		public final boolean isARGTYPES_KEYWORD() {
			return false;
		}
		public final boolean isCODE_KEYWORD() {
			return false;
		}
		public final boolean isFROM_KEYWORD() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isLEFT_SQUARE() {
			return false;
		}
		public final boolean isJAVA_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
}
